Project Chrono: chrono::vehicle::ChSuspension Class Reference

Public Member Functions | Protected Member Functions | Protected Attributes | List of all members
chrono::vehicle::ChSuspension Class Referenceabstract
VEHICLE module » Wheeled vehicles » Suspension subsystem

## Description

Base class for a suspension subsystem.

`#include <ChSuspension.h>`

Inheritance diagram for chrono::vehicle::ChSuspension:
[legend]
Collaboration diagram for chrono::vehicle::ChSuspension:
[legend]

## Public Member Functions
virtual bool | IsSteerable () const =0
| Specify whether or not this suspension can be steered.
virtual bool | IsIndependent () const =0
| Specify whether or not this is an independent suspension.
const ChVector3d & | GetRelPosition () const
| Get the location of the suspension subsystem relative to the associated chassis reference frame.
std::shared_ptr< ChBody > | GetSpindle (VehicleSide side) const
| Get a handle to the spindle body on the specified side.
std::shared_ptr< ChShaft > | GetAxle (VehicleSide side) const
| Get a handle to the axle shaft on the specified side.
std::shared_ptr< ChLinkLockRevolute > | GetRevolute (VehicleSide side) const
| Get a handle to the revolute joint on the specified side.
const ChVector3d & | GetSpindlePos (VehicleSide side) const
| Get the global location of the spindle on the specified side.
ChQuaternion | GetSpindleRot (VehicleSide side) const
| Get the orientation of the spindle body on the specified side.
const ChVector3d & | GetSpindleLinVel (VehicleSide side) const
| Get the linear velocity of the spindle body on the specified side.
ChVector3d | GetSpindleAngVel (VehicleSide side) const
| Get the angular velocity of the spindle body on the specified side.
double | GetAxleSpeed (VehicleSide side) const
| Get the angular speed of the axle on the specified side.
virtual void | Synchronize (double time)
| Synchronize this suspension subsystem.
virtual void | Advance (double step)
| Advance the state of the suspension subsystem by the specified time step.
void | ApplyAxleTorque (VehicleSide side, double torque)
| Apply the provided motor torque.
virtual void | Initialize (std::shared_ptr< ChChassis > chassis, std::shared_ptr< ChSubchassis > subchassis, std::shared_ptr< ChSteering > steering, const ChVector3d &location, double left_ang_vel=0, double right_ang_vel=0)
| Initialize this suspension subsystem.
virtual double | getSpindleRadius () const =0
| Return the radius of the spindle body (visualization only).
virtual double | getSpindleWidth () const =0
| Return the width of the spindle body (visualization only).
virtual void | AddVisualizationAssets (VisualizationType vis) override
| Add visualization assets for the suspension subsystem.
virtual void | RemoveVisualizationAssets () override
| Remove visualization assets for the suspension subsystem.
virtual std::shared_ptr< ChBody > | GetAntirollBody (VehicleSide side) const
| Specify the suspension body on the specified side to attach a possible antirollbar subsystem.
virtual std::shared_ptr< ChBody > | GetBrakeBody (VehicleSide side) const
| Specify the body on the specified side for a possible connection to brake subsystem.
virtual double | GetTrack ()=0
| Get the wheel track for the suspension subsystem.
virtual std::vector< ForceTSDA > | ReportSuspensionForce (VehicleSide side) const
| Return current suspension TSDA force information on the specified side.
virtual std::vector< ForceRSDA > | ReportSuspensionTorque (VehicleSide side) const
| Return current RSDA torque information on the specified side.
virtual void | LogConstraintViolations (VehicleSide side)
| Log current constraint violations.
void | ApplyParkingBrake (bool brake)
| Simple model of a parking brake.
Public Member Functions inherited from chrono::vehicle::ChPart
const std::string & | GetName () const
| Get the name identifier for this subsystem.
void | SetName (const std::string &name)
| Set the name identifier for this subsystem.
virtual std::string | GetTemplateName () const =0
| Get the name of the vehicle subsystem template.
bool | IsInitialized () const
| Return flag indicating whether or not the part is fully constructed.
double | GetMass () const
| Get the subsystem mass.
const ChFrame & | GetCOMFrame () const
| Get the current subsystem COM frame (relative to and expressed in the subsystem's reference frame).
const ChMatrix33 & | GetInertia () const
| Get the current subsystem inertia (relative to the subsystem COM frame).
const ChFrame & | GetTransform () const
| Get the current subsystem position relative to the global frame.
void | SetVisualizationType (VisualizationType vis)
| Set the visualization mode for this subsystem.
virtual void | SetOutput (bool state)
| Enable/disable output for this subsystem.
bool | OutputEnabled () const
| Return the output state for this subsystem.
virtual void | ExportComponentList (rapidjson::Document &jsonDocument) const
| Export this subsystem's component list to the specified JSON object.
virtual void | Output (ChVehicleOutput &database) const
| Output data for this subsystem's component list to the specified database.

## Protected Member Functions
| ChSuspension (const std::string &name)
| Construct a suspension subsystem with given name.
Protected Member Functions inherited from chrono::vehicle::ChPart
| ChPart (const std::string &name)
| Construct a vehicle subsystem with the specified name.
virtual void | InitializeInertiaProperties ()=0
| Initialize subsystem inertia properties.
virtual void | UpdateInertiaProperties ()=0
| Update subsystem inertia properties.
void | AddMass (double &mass)
| Add this subsystem's mass.
void | AddInertiaProperties (ChVector3d &com, ChMatrix33<> &inertia)
| Add this subsystem's inertia properties.
virtual void | Create (const rapidjson::Document &d)
| Create a vehicle subsystem from JSON data.
void | ExportBodyList (rapidjson::Document &jsonDocument, std::vector< std::shared_ptr< ChBody > > bodies) const
| Export the list of bodies to the specified JSON document.
void | ExportShaftList (rapidjson::Document &jsonDocument, std::vector< std::shared_ptr< ChShaft > > shafts) const
| Export the list of shafts to the specified JSON document.
void | ExportJointList (rapidjson::Document &jsonDocument, std::vector< std::shared_ptr< ChLink > > joints) const
| Export the list of joints to the specified JSON document.
void | ExportCouplesList (rapidjson::Document &jsonDocument, std::vector< std::shared_ptr< ChShaftsCouple > > couples) const
| Export the list of shaft couples to the specified JSON document.
void | ExportMarkerList (rapidjson::Document &jsonDocument, std::vector< std::shared_ptr< ChMarker > > markers) const
| Export the list of markers to the specified JSON document.
void | ExportLinSpringList (rapidjson::Document &jsonDocument, std::vector< std::shared_ptr< ChLinkTSDA > > springs) const
| Export the list of translational springs to the specified JSON document.
void | ExportRotSpringList (rapidjson::Document &jsonDocument, std::vector< std::shared_ptr< ChLinkRSDA > > springs) const
| Export the list of rotational springs to the specified JSON document.
void | ExportBodyLoadList (rapidjson::Document &jsonDocument, std::vector< std::shared_ptr< ChLoadBodyBody > > loads) const
| Export the list of body-body loads to the specified JSON document.

## Protected Attributes
ChVector3d | m_rel_loc
| location relative to chassis
std::shared_ptr< ChBody > | m_spindle [2]
| handles to spindle bodies
std::shared_ptr< ChShaft > | m_axle [2]
| handles to axle shafts
std::shared_ptr< ChShaftBodyRotation > | m_axle_to_spindle [2]
| handles to spindle-shaft connectors
std::shared_ptr< ChLinkLockRevolute > | m_revolute [2]
| handles to spindle revolute joints
Protected Attributes inherited from chrono::vehicle::ChPart
std::string | m_name
| subsystem name
bool | m_initialized
| specifies whether ot not the part is fully constructed
bool | m_output
| specifies whether or not output is generated for this subsystem
std::shared_ptr< ChPart > | m_parent
| parent subsystem (empty if parent is vehicle)
double | m_mass
| subsystem mass
ChMatrix33 | m_inertia
| inertia tensor (relative to subsystem COM)
ChFrame | m_com
| COM frame (relative to subsystem reference frame).
ChFrame | m_xform
| subsystem frame expressed in the global frame

## Additional Inherited Members
Static Public Member Functions inherited from chrono::vehicle::ChPart
static ChMatrix33 | TransformInertiaMatrix (const ChVector3d &moments, const ChVector3d &products, const ChMatrix33<> &vehicle_rot, const ChMatrix33<> &body_rot)
| Utility function for transforming inertia tensors between centroidal frames.
Static Protected Member Functions inherited from chrono::vehicle::ChPart
static void | RemoveVisualizationAssets (std::shared_ptr< ChPhysicsItem > item)
| Erase all visual shapes from the visual model associated with the specified physics item (if any).
static void | RemoveVisualizationAsset (std::shared_ptr< ChPhysicsItem > item, std::shared_ptr< ChVisualShape > shape)
| Erase the given shape from the visual model associated with the specified physics item (if any).

## Member Function Documentation

## ◆ AddVisualizationAssets()

void chrono::vehicle::ChSuspension::AddVisualizationAssets | ( | VisualizationType | vis | ) |
| overridevirtual

Add visualization assets for the suspension subsystem.

This default implementation uses primitives for spindle visualization.

Reimplemented from chrono::vehicle::ChPart.

Reimplemented in chrono::vehicle::ChDeDionAxle, chrono::vehicle::ChDoubleWishbone, chrono::vehicle::ChDoubleWishboneReduced, chrono::vehicle::ChGenericWheeledSuspension, chrono::vehicle::ChHendricksonPRIMAXX, chrono::vehicle::ChLeafspringAxle, chrono::vehicle::ChMacPhersonStrut, chrono::vehicle::ChMultiLink, chrono::vehicle::ChPushPipeAxle, chrono::vehicle::ChRigidPanhardAxle, chrono::vehicle::ChRigidPinnedAxle, chrono::vehicle::ChSAELeafspringAxle, chrono::vehicle::ChSemiTrailingArm, chrono::vehicle::ChSingleWishbone, chrono::vehicle::ChSolidAxle, chrono::vehicle::ChSolidBellcrankThreeLinkAxle, chrono::vehicle::ChSolidThreeLinkAxle, chrono::vehicle::ChThreeLinkIRS, chrono::vehicle::ChToeBarDeDionAxle, chrono::vehicle::ChToeBarLeafspringAxle, chrono::vehicle::ChToeBarPushPipeAxle, and chrono::vehicle::ChToeBarRigidPanhardAxle.

## ◆ ApplyAxleTorque()

void chrono::vehicle::ChSuspension::ApplyAxleTorque | ( | VehicleSide | side,
|  | double | torque )

Apply the provided motor torque.

The given torque is applied to the specified (left or right) axle. This function provides the interface to the drivetrain subsystem (intermediated by the vehicle system).

Parameters

  side | indicates the axle (left or right) where the torque should be applied
  torque | value of applied torque

## ◆ GetAntirollBody()

virtual std::shared_ptr< ChBody > chrono::vehicle::ChSuspension::GetAntirollBody | ( | VehicleSide | side | ) | const
| inlinevirtual

Specify the suspension body on the specified side to attach a possible antirollbar subsystem.

The default implementation returns a NULL pointer.

Reimplemented in chrono::vehicle::ChDoubleWishbone, chrono::vehicle::ChDoubleWishboneReduced, chrono::vehicle::ChGenericWheeledSuspension, chrono::vehicle::ChMacPhersonStrut, chrono::vehicle::ChMultiLink, chrono::vehicle::ChSemiTrailingArm, chrono::vehicle::ChSingleWishbone, and chrono::vehicle::ChThreeLinkIRS.

## ◆ GetBrakeBody()

virtual std::shared_ptr< ChBody > chrono::vehicle::ChSuspension::GetBrakeBody | ( | VehicleSide | side | ) | const
| inlinevirtual

Specify the body on the specified side for a possible connection to brake subsystem.

The default implementation returns a NULL pointer (indicating that a brake should connect to the chassis).

## ◆ GetRelPosition()

const ChVector3d & chrono::vehicle::ChSuspension::GetRelPosition | ( |  | ) | const
| inline

Get the location of the suspension subsystem relative to the associated chassis reference frame.

The suspension reference frame is always aligned with the chassis reference frame.

## ◆ GetSpindleAngVel()

ChVector3d chrono::vehicle::ChSuspension::GetSpindleAngVel | ( | VehicleSide | side | ) | const
| inline

Get the angular velocity of the spindle body on the specified side.

Return the angular velocity of the spindle frame, expressed in the global reference frame.

## ◆ GetSpindleLinVel()

const ChVector3d & chrono::vehicle::ChSuspension::GetSpindleLinVel | ( | VehicleSide | side | ) | const
| inline

Get the linear velocity of the spindle body on the specified side.

Return the linear velocity of the spindle center, expressed in the global reference frame.

## ◆ getSpindleRadius()

virtual double chrono::vehicle::ChSuspension::getSpindleRadius | ( |  | ) | const
| pure virtual

Return the radius of the spindle body (visualization only).

Implemented in chrono::vehicle::artcar::ARTcar_DoubleWishboneFront, chrono::vehicle::artcar::ARTcar_DoubleWishboneRear, chrono::vehicle::bmw::BMW_E90_DoubleWishbone, chrono::vehicle::bmw::BMW_E90_MacPhersonStrut, chrono::vehicle::bmw::BMW_E90_MacPhersonStrut, chrono::vehicle::bmw::BMW_E90_MacPhersonStrut, chrono::vehicle::citybus::CityBus_SolidAxleFront, chrono::vehicle::citybus::CityBus_SolidAxleRear, chrono::vehicle::DeDionAxle, chrono::vehicle::DoubleWishbone, chrono::vehicle::DoubleWishboneReduced, chrono::vehicle::duro::Duro_ToeBarDeDionAxle, chrono::vehicle::feda::FEDA_DoubleWishboneFront, chrono::vehicle::feda::FEDA_DoubleWishboneRear, chrono::vehicle::fmtv::FMTV_ToebarLeafspringAxle, chrono::vehicle::fmtv::LMTV_LeafspringAxle, chrono::vehicle::fmtv::MTV_LeafspringAxle1, chrono::vehicle::fmtv::MTV_LeafspringAxle2, chrono::vehicle::gator::Gator_RigidSuspension, chrono::vehicle::gator::Gator_SingleWishbone, chrono::vehicle::gclass::G500_FrontAxle, chrono::vehicle::gclass::G500_RearAxle, chrono::vehicle::generic::Generic_DoubleWishbone, chrono::vehicle::generic::Generic_DoubleWishboneFront, chrono::vehicle::generic::Generic_DoubleWishboneRear, chrono::vehicle::generic::Generic_DoubleWishboneReducedFront, chrono::vehicle::generic::Generic_DoubleWishboneReducedRear, chrono::vehicle::generic::Generic_HendricksonPRIMAXX, chrono::vehicle::generic::Generic_MacPhersonStrut, chrono::vehicle::generic::Generic_MultiLink, chrono::vehicle::generic::Generic_RigidPinnedAxle, chrono::vehicle::generic::Generic_RigidSuspension, chrono::vehicle::generic::Generic_SolidAxle, chrono::vehicle::GenericWheeledSuspension, chrono::vehicle::HendricksonPRIMAXX, chrono::vehicle::hmmwv::HMMWV_DoubleWishboneFront, chrono::vehicle::hmmwv::HMMWV_DoubleWishboneRear, chrono::vehicle::hmmwv::HMMWV_DoubleWishboneReducedFront, chrono::vehicle::hmmwv::HMMWV_DoubleWishboneReducedRear, chrono::vehicle::kraz::Kraz_tractor_FrontSuspension, chrono::vehicle::kraz::Kraz_tractor_RearSuspension, chrono::vehicle::kraz::Kraz_trailer_Suspension, chrono::vehicle::LeafspringAxle, chrono::vehicle::MacPhersonStrut, chrono::vehicle::mrole::mrole_DoubleWishboneFront, chrono::vehicle::mrole::mrole_DoubleWishboneRear, chrono::vehicle::mrole::mrole_DoubleWishboneReducedFront, chrono::vehicle::mrole::mrole_DoubleWishboneReducedRear, chrono::vehicle::MultiLink, chrono::vehicle::PushPipeAxle, chrono::vehicle::RigidPanhardAxle, chrono::vehicle::RigidPinnedAxle, chrono::vehicle::RigidSuspension, chrono::vehicle::SAELeafspringAxle, chrono::vehicle::SAEToeBarLeafspringAxle, chrono::vehicle::sedan::Sedan_DoubleWishbone, chrono::vehicle::sedan::Sedan_MultiLink, chrono::vehicle::SemiTrailingArm, chrono::vehicle::SingleWishbone, chrono::vehicle::SolidAxle, chrono::vehicle::SolidBellcrankThreeLinkAxle, chrono::vehicle::SolidThreeLinkAxle, chrono::vehicle::ThreeLinkIRS, chrono::vehicle::ToeBarDeDionAxle, chrono::vehicle::ToeBarLeafspringAxle, chrono::vehicle::ToeBarPushPipeAxle, chrono::vehicle::ToeBarRigidPanhardAxle, chrono::vehicle::uaz::UAZBUS_LeafspringAxle, chrono::vehicle::uaz::UAZBUS_SAELeafspringAxle, chrono::vehicle::uaz::UAZBUS_SAEToeBarLeafspringAxle, chrono::vehicle::uaz::UAZBUS_ToeBarLeafspringAxle, chrono::vehicle::unimog::U401_PushPipeAxle, and chrono::vehicle::unimog::U401_ToeBarPushPipeAxle.

## ◆ GetSpindleRot()

ChQuaternion chrono::vehicle::ChSuspension::GetSpindleRot | ( | VehicleSide | side | ) | const

Get the orientation of the spindle body on the specified side.

The spindle body orientation is returned as a quaternion representing a rotation with respect to the global reference frame.

## ◆ getSpindleWidth()

virtual double chrono::vehicle::ChSuspension::getSpindleWidth | ( |  | ) | const
| pure virtual

Return the width of the spindle body (visualization only).

Implemented in chrono::vehicle::artcar::ARTcar_DoubleWishboneFront, chrono::vehicle::artcar::ARTcar_DoubleWishboneRear, chrono::vehicle::bmw::BMW_E90_DoubleWishbone, chrono::vehicle::bmw::BMW_E90_MacPhersonStrut, chrono::vehicle::bmw::BMW_E90_MacPhersonStrut, chrono::vehicle::bmw::BMW_E90_MacPhersonStrut, chrono::vehicle::citybus::CityBus_SolidAxleFront, chrono::vehicle::citybus::CityBus_SolidAxleRear, chrono::vehicle::DeDionAxle, chrono::vehicle::DoubleWishbone, chrono::vehicle::DoubleWishboneReduced, chrono::vehicle::duro::Duro_ToeBarDeDionAxle, chrono::vehicle::feda::FEDA_DoubleWishboneFront, chrono::vehicle::feda::FEDA_DoubleWishboneRear, chrono::vehicle::fmtv::FMTV_ToebarLeafspringAxle, chrono::vehicle::fmtv::LMTV_LeafspringAxle, chrono::vehicle::fmtv::MTV_LeafspringAxle1, chrono::vehicle::fmtv::MTV_LeafspringAxle2, chrono::vehicle::gator::Gator_RigidSuspension, chrono::vehicle::gator::Gator_SingleWishbone, chrono::vehicle::gclass::G500_FrontAxle, chrono::vehicle::gclass::G500_RearAxle, chrono::vehicle::generic::Generic_DoubleWishbone, chrono::vehicle::generic::Generic_DoubleWishboneFront, chrono::vehicle::generic::Generic_DoubleWishboneRear, chrono::vehicle::generic::Generic_DoubleWishboneReducedFront, chrono::vehicle::generic::Generic_DoubleWishboneReducedRear, chrono::vehicle::generic::Generic_HendricksonPRIMAXX, chrono::vehicle::generic::Generic_MacPhersonStrut, chrono::vehicle::generic::Generic_MultiLink, chrono::vehicle::generic::Generic_RigidPinnedAxle, chrono::vehicle::generic::Generic_RigidSuspension, chrono::vehicle::generic::Generic_SolidAxle, chrono::vehicle::GenericWheeledSuspension, chrono::vehicle::HendricksonPRIMAXX, chrono::vehicle::hmmwv::HMMWV_DoubleWishboneFront, chrono::vehicle::hmmwv::HMMWV_DoubleWishboneRear, chrono::vehicle::hmmwv::HMMWV_DoubleWishboneReducedFront, chrono::vehicle::hmmwv::HMMWV_DoubleWishboneReducedRear, chrono::vehicle::kraz::Kraz_tractor_FrontSuspension, chrono::vehicle::kraz::Kraz_tractor_RearSuspension, chrono::vehicle::kraz::Kraz_trailer_Suspension, chrono::vehicle::LeafspringAxle, chrono::vehicle::MacPhersonStrut, chrono::vehicle::mrole::mrole_DoubleWishboneFront, chrono::vehicle::mrole::mrole_DoubleWishboneRear, chrono::vehicle::mrole::mrole_DoubleWishboneReducedFront, chrono::vehicle::mrole::mrole_DoubleWishboneReducedRear, chrono::vehicle::MultiLink, chrono::vehicle::PushPipeAxle, chrono::vehicle::RigidPanhardAxle, chrono::vehicle::RigidPinnedAxle, chrono::vehicle::RigidSuspension, chrono::vehicle::SAELeafspringAxle, chrono::vehicle::SAEToeBarLeafspringAxle, chrono::vehicle::sedan::Sedan_DoubleWishbone, chrono::vehicle::sedan::Sedan_MultiLink, chrono::vehicle::SemiTrailingArm, chrono::vehicle::SingleWishbone, chrono::vehicle::SolidAxle, chrono::vehicle::SolidBellcrankThreeLinkAxle, chrono::vehicle::SolidThreeLinkAxle, chrono::vehicle::ThreeLinkIRS, chrono::vehicle::ToeBarDeDionAxle, chrono::vehicle::ToeBarLeafspringAxle, chrono::vehicle::ToeBarPushPipeAxle, chrono::vehicle::ToeBarRigidPanhardAxle, chrono::vehicle::uaz::UAZBUS_LeafspringAxle, chrono::vehicle::uaz::UAZBUS_SAELeafspringAxle, chrono::vehicle::uaz::UAZBUS_SAEToeBarLeafspringAxle, chrono::vehicle::uaz::UAZBUS_ToeBarLeafspringAxle, chrono::vehicle::unimog::U401_PushPipeAxle, and chrono::vehicle::unimog::U401_ToeBarPushPipeAxle.

## ◆ GetTrack()

virtual double chrono::vehicle::ChSuspension::GetTrack | ( |  | ) |
| pure virtual

Get the wheel track for the suspension subsystem.

Implemented in chrono::vehicle::bmw::BMW_E90_MacPhersonStrut, chrono::vehicle::bmw::BMW_E90_MacPhersonStrut, chrono::vehicle::bmw::BMW_E90_MacPhersonStrut, chrono::vehicle::ChDeDionAxle, chrono::vehicle::ChDoubleWishbone, chrono::vehicle::ChDoubleWishboneReduced, chrono::vehicle::ChGenericWheeledSuspension, chrono::vehicle::ChHendricksonPRIMAXX, chrono::vehicle::ChLeafspringAxle, chrono::vehicle::ChMacPhersonStrut, chrono::vehicle::ChMultiLink, chrono::vehicle::ChPushPipeAxle, chrono::vehicle::ChRigidPanhardAxle, chrono::vehicle::ChRigidPinnedAxle, chrono::vehicle::ChRigidSuspension, chrono::vehicle::ChSAELeafspringAxle, chrono::vehicle::ChSemiTrailingArm, chrono::vehicle::ChSingleWishbone, chrono::vehicle::ChSolidAxle, chrono::vehicle::ChSolidBellcrankThreeLinkAxle, chrono::vehicle::ChSolidThreeLinkAxle, chrono::vehicle::ChThreeLinkIRS, chrono::vehicle::ChToeBarDeDionAxle, chrono::vehicle::ChToeBarLeafspringAxle, chrono::vehicle::ChToeBarPushPipeAxle, and chrono::vehicle::ChToeBarRigidPanhardAxle.

## ◆ Initialize()

void chrono::vehicle::ChSuspension::Initialize | ( | std::shared_ptr< ChChassis > | chassis,
|  | std::shared_ptr< ChSubchassis > | subchassis,
|  | std::shared_ptr< ChSteering > | steering,
|  | const ChVector3d & | location,
|  | double | left_ang_vel = 0,
|  | double | right_ang_vel = 0 )
| virtual

Initialize this suspension subsystem.

The suspension subsystem is initialized by attaching it to the specified chassis and (if provided) to the specified subchassis, at the specified location (with respect to and expressed in the reference frame of the chassis). It is assumed that the suspension reference frame is always aligned with the chassis reference frame. If a steering subsystem is provided, the suspension tierods are to be attached to the steering's central link body (steered suspension); otherwise they are to be attached to the chassis (non-steered suspension).

Parameters

  [in] | chassis | associated chassis subsystem
  [in] | subchassis | associated subchassis subsystem (may be null)
  [in] | steering | associated steering subsystem (may be null)
  [in] | location | location relative to the chassis frame
  [in] | left_ang_vel | initial angular velocity of left wheel
  [in] | right_ang_vel | initial angular velocity of right wheel

Reimplemented in chrono::vehicle::ChDeDionAxle, chrono::vehicle::ChDoubleWishbone, chrono::vehicle::ChDoubleWishboneReduced, chrono::vehicle::ChGenericWheeledSuspension, chrono::vehicle::ChHendricksonPRIMAXX, chrono::vehicle::ChLeafspringAxle, chrono::vehicle::ChMacPhersonStrut, chrono::vehicle::ChMultiLink, chrono::vehicle::ChPushPipeAxle, chrono::vehicle::ChRigidPanhardAxle, chrono::vehicle::ChRigidPinnedAxle, chrono::vehicle::ChRigidSuspension, chrono::vehicle::ChSAELeafspringAxle, chrono::vehicle::ChSemiTrailingArm, chrono::vehicle::ChSingleWishbone, chrono::vehicle::ChSolidAxle, chrono::vehicle::ChSolidBellcrankThreeLinkAxle, chrono::vehicle::ChSolidThreeLinkAxle, chrono::vehicle::ChThreeLinkIRS, chrono::vehicle::ChToeBarDeDionAxle, chrono::vehicle::ChToeBarLeafspringAxle, chrono::vehicle::ChToeBarPushPipeAxle, chrono::vehicle::ChToeBarRigidPanhardAxle, chrono::vehicle::feda::FEDA_DoubleWishboneFront, and chrono::vehicle::feda::FEDA_DoubleWishboneRear.

## ◆ IsIndependent()

virtual bool chrono::vehicle::ChSuspension::IsIndependent | ( |  | ) | const
| pure virtual

Specify whether or not this is an independent suspension.

Implemented in chrono::vehicle::ChDeDionAxle, chrono::vehicle::ChDoubleWishbone, chrono::vehicle::ChDoubleWishboneReduced, chrono::vehicle::ChHendricksonPRIMAXX, chrono::vehicle::ChLeafspringAxle, chrono::vehicle::ChMacPhersonStrut, chrono::vehicle::ChMultiLink, chrono::vehicle::ChPushPipeAxle, chrono::vehicle::ChRigidPanhardAxle, chrono::vehicle::ChRigidPinnedAxle, chrono::vehicle::ChRigidSuspension, chrono::vehicle::ChSAELeafspringAxle, chrono::vehicle::ChSemiTrailingArm, chrono::vehicle::ChSingleWishbone, chrono::vehicle::ChSolidAxle, chrono::vehicle::ChSolidBellcrankThreeLinkAxle, chrono::vehicle::ChSolidThreeLinkAxle, chrono::vehicle::ChThreeLinkIRS, chrono::vehicle::ChToeBarDeDionAxle, chrono::vehicle::ChToeBarLeafspringAxle, chrono::vehicle::ChToeBarPushPipeAxle, chrono::vehicle::ChToeBarRigidPanhardAxle, and chrono::vehicle::GenericWheeledSuspension.

## ◆ IsSteerable()

virtual bool chrono::vehicle::ChSuspension::IsSteerable | ( |  | ) | const
| pure virtual

Specify whether or not this suspension can be steered.

Implemented in chrono::vehicle::ChDeDionAxle, chrono::vehicle::ChDoubleWishbone, chrono::vehicle::ChDoubleWishboneReduced, chrono::vehicle::ChHendricksonPRIMAXX, chrono::vehicle::ChLeafspringAxle, chrono::vehicle::ChMacPhersonStrut, chrono::vehicle::ChMultiLink, chrono::vehicle::ChPushPipeAxle, chrono::vehicle::ChRigidPanhardAxle, chrono::vehicle::ChRigidPinnedAxle, chrono::vehicle::ChRigidSuspension, chrono::vehicle::ChSAELeafspringAxle, chrono::vehicle::ChSemiTrailingArm, chrono::vehicle::ChSingleWishbone, chrono::vehicle::ChSolidAxle, chrono::vehicle::ChSolidBellcrankThreeLinkAxle, chrono::vehicle::ChSolidThreeLinkAxle, chrono::vehicle::ChThreeLinkIRS, chrono::vehicle::ChToeBarDeDionAxle, chrono::vehicle::ChToeBarLeafspringAxle, chrono::vehicle::ChToeBarPushPipeAxle, chrono::vehicle::ChToeBarRigidPanhardAxle, and chrono::vehicle::GenericWheeledSuspension.

## ◆ LogConstraintViolations()

virtual void chrono::vehicle::ChSuspension::LogConstraintViolations | ( | VehicleSide | side | ) |
| inlinevirtual

Log current constraint violations.

Reimplemented in chrono::vehicle::ChDeDionAxle, chrono::vehicle::ChDoubleWishbone, chrono::vehicle::ChDoubleWishboneReduced, chrono::vehicle::ChGenericWheeledSuspension, chrono::vehicle::ChHendricksonPRIMAXX, chrono::vehicle::ChLeafspringAxle, chrono::vehicle::ChMacPhersonStrut, chrono::vehicle::ChMultiLink, chrono::vehicle::ChPushPipeAxle, chrono::vehicle::ChRigidPanhardAxle, chrono::vehicle::ChRigidPinnedAxle, chrono::vehicle::ChRigidSuspension, chrono::vehicle::ChSAELeafspringAxle, chrono::vehicle::ChSemiTrailingArm, chrono::vehicle::ChSingleWishbone, chrono::vehicle::ChSolidAxle, chrono::vehicle::ChSolidBellcrankThreeLinkAxle, chrono::vehicle::ChSolidThreeLinkAxle, chrono::vehicle::ChThreeLinkIRS, chrono::vehicle::ChToeBarDeDionAxle, chrono::vehicle::ChToeBarLeafspringAxle, chrono::vehicle::ChToeBarPushPipeAxle, and chrono::vehicle::ChToeBarRigidPanhardAxle.

## ◆ RemoveVisualizationAssets()

void chrono::vehicle::ChSuspension::RemoveVisualizationAssets | ( |  | ) |
| overridevirtual

Remove visualization assets for the suspension subsystem.

Reimplemented from chrono::vehicle::ChPart.

Reimplemented in chrono::vehicle::ChDeDionAxle, chrono::vehicle::ChDoubleWishbone, chrono::vehicle::ChDoubleWishboneReduced, chrono::vehicle::ChGenericWheeledSuspension, chrono::vehicle::ChHendricksonPRIMAXX, chrono::vehicle::ChLeafspringAxle, chrono::vehicle::ChMacPhersonStrut, chrono::vehicle::ChMultiLink, chrono::vehicle::ChPushPipeAxle, chrono::vehicle::ChRigidPanhardAxle, chrono::vehicle::ChRigidPinnedAxle, chrono::vehicle::ChSAELeafspringAxle, chrono::vehicle::ChSemiTrailingArm, chrono::vehicle::ChSingleWishbone, chrono::vehicle::ChSolidAxle, chrono::vehicle::ChSolidBellcrankThreeLinkAxle, chrono::vehicle::ChSolidThreeLinkAxle, chrono::vehicle::ChThreeLinkIRS, chrono::vehicle::ChToeBarDeDionAxle, chrono::vehicle::ChToeBarLeafspringAxle, chrono::vehicle::ChToeBarPushPipeAxle, and chrono::vehicle::ChToeBarRigidPanhardAxle.

## ◆ ReportSuspensionForce()

virtual std::vector< ForceTSDA > chrono::vehicle::ChSuspension::ReportSuspensionForce | ( | VehicleSide | side | ) | const
| inlinevirtual

Return current suspension TSDA force information on the specified side.

Reimplemented in chrono::vehicle::ChDeDionAxle, chrono::vehicle::ChDoubleWishbone, chrono::vehicle::ChDoubleWishboneReduced, chrono::vehicle::ChGenericWheeledSuspension, chrono::vehicle::ChHendricksonPRIMAXX, chrono::vehicle::ChLeafspringAxle, chrono::vehicle::ChMacPhersonStrut, chrono::vehicle::ChMultiLink, chrono::vehicle::ChPushPipeAxle, chrono::vehicle::ChRigidPanhardAxle, chrono::vehicle::ChRigidPinnedAxle, chrono::vehicle::ChRigidSuspension, chrono::vehicle::ChSAELeafspringAxle, chrono::vehicle::ChSemiTrailingArm, chrono::vehicle::ChSingleWishbone, chrono::vehicle::ChSolidAxle, chrono::vehicle::ChSolidBellcrankThreeLinkAxle, chrono::vehicle::ChSolidThreeLinkAxle, chrono::vehicle::ChThreeLinkIRS, chrono::vehicle::ChToeBarDeDionAxle, chrono::vehicle::ChToeBarLeafspringAxle, chrono::vehicle::ChToeBarPushPipeAxle, and chrono::vehicle::ChToeBarRigidPanhardAxle.

## ◆ ReportSuspensionTorque()

virtual std::vector< ForceRSDA > chrono::vehicle::ChSuspension::ReportSuspensionTorque | ( | VehicleSide | side | ) | const
| inlinevirtual

Return current RSDA torque information on the specified side.

Reimplemented in chrono::vehicle::ChGenericWheeledSuspension.

The documentation for this class was generated from the following files:

- D:/W/B/src/chrono-9.0.1/src/chrono_vehicle/wheeled_vehicle/ChSuspension.h
- D:/W/B/src/chrono-9.0.1/src/chrono_vehicle/wheeled_vehicle/ChSuspension.cpp